SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Tests'!

Dictionary subclass: #MDPropertyDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPropertyDictionary methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2004 00:49'!
doesNotUnderstand: aMessage
	aMessage selector isUnary ifTrue: [^ self at: aMessage selector ifAbsent: [nil]].
	(aMessage selector isKeyword
		and: [aMessage arguments size = 1])
			ifTrue: [^ self
						at: aMessage selector allButLast asSymbol
						put: aMessage arguments first].
	super doesNotUnderstand: aMessage.! !

TestCase subclass: #MDTestImageProxy
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/29/2004 01:13'!
testLoadAndUpdate
	| original retrieved |
	original _ self methodSnapshot.
	original properties 
		source: self defaultSource;
		author: self defaultAuthor;
		timeStamp: self defaultTimeStamp.
	proxy loadSnapshot: original.
	
	retrieved _ self methodSnapshot.
	proxy updateSnapshot: retrieved.
	self assert: original properties = retrieved properties! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/29/2004 01:45'!
defaultTimeStamp
	^  TimeStamp readFrom: '11/29/2004 01:44' readStream! !

MDTestImageProxy subclass: #MDTestSqueakImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestSqueakImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 23:34'!
methodProperty: propName inClass: className atSelector: aSelector 
	| class |
	class := self classNamed: className.
	propName = #source ifTrue: [^ class sourceCodeAt: aSelector].
	^ nil! !

!MDTestSqueakImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 23:20'!
proxyClass
	^ MDSqueakImageProxy! !

!MDTestSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 23:35'!
classNamed: name
	^ Smalltalk at: name asSymbol! !

!MDTestSqueakImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 23:34'!
methodProperty: propName inClass: className atSelector: aSelector put: aValue
	| class |
	class := self classNamed: className.
	propName = #source ifTrue: [^ class compile: aValue].
	^ nil! !

!MDTestImageProxy methodsFor: 'proxy access' stamp: 'cwp 11/28/2004 18:52'!
methodProperty: aSymbol
	^ self 
		methodProperty: aSymbol 
		inClass: self defaultClassName
		atSelector: self defaultSelector! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/28/2004 23:36'!
testCurrentDefinition
	| snap |
	self methodProperty: #source put: self defaultSource.
	snap := self methodSnapshot.
	proxy updateSnapshot: snap.
	self assert: (snap properties at: #source) = self defaultSource! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:57'!
methodProperty: aSymbol inClass: aString atSelector: aSelector put: aValue
	self subclassResponsibility! !

!MDTestImageProxy class methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2004 16:57'!
isAbstract
	^ self name = #MDTestImageProxy! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/29/2004 01:35'!
defaultSource
	^ 'hasTimestamp
	^ true'! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/29/2004 01:34'!
defaultSelector
	^ #hasTimestamp! !

!MDTestImageProxy methodsFor: 'constructing' stamp: 'cwp 11/28/2004 19:00'!
methodSnapshot
	^MDElementDefinition forElement: (MDMethodElement 
										className: self defaultClassName
										selector: self defaultSelector)! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/28/2004 19:03'!
testUpdateDoesntChangeElement
	| snap original |
	snap := self methodSnapshot.
	original := snap element.
	proxy updateSnapshot: snap.
	self assert: snap element = original! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/29/2004 01:11'!
testLoadDefinition
	| snap |
	snap _ self methodSnapshot.
	snap properties 
			source: self defaultSource;
			author: self defaultAuthor;
			timeStamp: self defaultTimeStamp.
	proxy loadSnapshot: snap.
	self assert: (self methodProperty: #source) = self defaultSource! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 16:49'!
proxyClass
	self subclassResponsibility! !

!MDTestImageProxy methodsFor: 'running' stamp: 'cwp 11/28/2004 16:49'!
setUp
	proxy _ self proxyClass new! !

!MDTestImageProxy methodsFor: 'proxy access' stamp: 'cwp 11/28/2004 18:56'!
methodProperty: aSymbol put: aValue
	^ self 
		methodProperty: aSymbol 
		inClass: self defaultClassName 
		atSelector: self defaultSelector 
		put: aValue! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 23:58'!
defaultAuthor
	^ 'abc'! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/29/2004 01:34'!
defaultClassName
	^ #BogusC! !

MDTestImageProxy subclass: #MDTestFakeImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:57'!
methodProperty: aSymbol inClass: aString atSelector: aSelector put: aValue 
	| element |
	element := MDMethodElement className: aString selector: aSelector.
	(proxy at: element) at: aSymbol put: aValue! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 23:38'!
defaultSource
	^ 'one ^ 1'! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:58'!
defaultClassName
	^'Test'! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 16:55'!
proxyClass
	^ MDFakeImageProxy! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:56'!
methodProperty: aSymbol inClass: aString atSelector: aSelector 
	| element |
	element := MDMethodElement className: aString selector: aSelector.
	^ (proxy at: element) at: aSymbol ifAbsent: [nil]! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:58'!
defaultSelector
	^ #method1! !

!MDTestImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:57'!
methodProperty: aSymbol inClass: aString atSelector: aSelector 
	self subclassResponsibility! !

Object subclass: #MDElementDefinition
	instanceVariableNames: 'element properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementDefinition methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDElementDefinition class methodsFor: 'instance creation' stamp: 'cwp 11/28/2004 12:52'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDElementDefinition methodsFor: 'initialize-release' stamp: 'cwp 11/29/2004 00:50'!
initializeWithElement: anElement
	element _ anElement.
	properties _ MDPropertyDictionary new! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'cwp 11/28/2004 12:56'!
element
	^ element! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:55'!
updateFrom: anImageProxy
	element update: properties from: anImageProxy! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:54'!
loadInto: anImageProxy
	element load: properties into: anImageProxy! !

Object subclass: #MDImageElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'image proxy' stamp: 'avi 11/28/2004 16:08'!
load: propDict into: anImageProxy
	self subclassResponsibility! !

MDImageElement subclass: #MDMethodElement
	instanceVariableNames: 'className selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 13:01'!
update: propDict from: anImageProxy
	anImageProxy update: propDict forMethodElement: self! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:02'!
initializeWithClassName: aString selector: aSymbol
	className _ aString.
	selector _ aSymbol! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 11/28/2004 15:23'!
hash
	^ (className, '|', selector) hash! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 11/28/2004 15:21'!
= other
	^ self class = other class 
		and: [className = other className] 
		and: [self selector = other selector]! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
className
	^ className! !

!MDMethodElement methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:59'!
load: propDict into: anImageProxy
	anImageProxy load: propDict forMethodElement: self! !

!MDMethodElement class methodsFor: 'as yet unclassified' stamp: 'avi 11/28/2004 16:02'!
className: aString selector: aSymbol
	^ self basicNew initializeWithClassName: aString selector: aSymbol! !

!MDImageElement methodsFor: 'image proxy' stamp: 'avi 11/28/2004 16:08'!
update: propDict from: anImageProxy
	self subclassResponsibility! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

Object subclass: #MDImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDImageProxy subclass: #MDFakeImageProxy
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFakeImageProxy methodsFor: 'public' stamp: 'cwp 11/28/2004 15:34'!
update: propDict forMethodElement: aMethodElement
	(self at: aMethodElement)
		keysAndValuesDo: [:prop :value | propDict at: prop put: value]! !

!MDFakeImageProxy methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:23'!
initialize
	dict _ Dictionary new! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:35'!
at: anElement
	^ dict at: anElement ifAbsentPut: [Dictionary new]! !

!MDFakeImageProxy methodsFor: 'public' stamp: 'cwp 11/28/2004 15:38'!
load: propDict forMethodElement: aMethodElement
	self at: aMethodElement put: propDict! !

MDImageProxy subclass: #MDSqueakImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDSqueakImageProxy methodsFor: 'public' stamp: 'cwp 11/29/2004 01:10'!
load: properties forMethodElement: aMethodElement 
	| class |
	class := self classNamed: aMethodElement className.
	class
		compile: properties source
		classified: properties category
		withStamp: (self stampFromProperties: properties)
		notifying: nil
		logSource: true! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:43'!
putAuthorInto: properties forMethod: aMethodElement 
	| cm |
	cm := self compiledMethodForElement: aMethodElement.
	properties author: (cm timeStamp copyUpTo: $ )! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:40'!
compiledMethodForElement: aMethodElement 
	^(self classNamed: aMethodElement className) 
		compiledMethodAt: aMethodElement selector! !

!MDSqueakImageProxy methodsFor: 'public' stamp: 'cwp 11/29/2004 01:19'!
update: properties forMethodElement: aMethodElement 
	self putSourceInto: properties forMethod: aMethodElement.
	self putTimeStampInto: properties forMethod: aMethodElement.
	self putAuthorInto: properties forMethod: aMethodElement.! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 23:48'!
classNamed: name 
	^ Smalltalk at: name asSymbol! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:42'!
putTimeStampInto: properties forMethod: aMethodElement 
	| cm |
	cm := self compiledMethodForElement: aMethodElement.
	properties timeStamp: (TimeStamp fromMethodTimeStamp: cm timeStamp)! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:06'!
stampFromProperties: properties
	^ String streamContents: 
		[:stream |
		stream nextPutAll: properties author.
		stream nextPut: $ .
		properties timeStamp asDate printOn: stream format: #(2 1 3 $/ 1 1).
		stream nextPut: $ .
		properties timeStamp asTime print24: true showSeconds: false on: stream]
		! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:21'!
putSourceInto: properties forMethod: aMethodElement 
	properties source: ((self classNamed: aMethodElement className) 
						sourceCodeAt: (aMethodElement selector)).! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:07'!
loadSnapshot: aSnapshot
	aSnapshot loadInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:06'!
updateSnapshot: aSnapshot
	aSnapshot updateFrom: self! !
